{"openapi":"3.0.1","info":{"title":"API for Student Profile.","description":"This CRUD API is for Student Profile, tied to a Digital ID for a particular student in BC.","version":"1"},"servers":[{"url":"https://student-profile-api-75e61b-dev.apps.silver.devops.gov.bc.ca","description":"Generated server url"}],"security":[{"OAUTH2":["READ_STUDENT_PROFILE","WRITE_STUDENT_PROFILE"]}],"tags":[{"name":"findStudentProfiles","description":"This api method will accept all or individual parameters and search the DB. if any parameter is null then it will be not included in the query."}],"paths":{"/api/v1/student-profile":{"get":{"tags":["findStudentProfiles"],"operationId":"findStudentProfiles","parameters":[{"name":"digitalID","in":"query","required":false,"schema":{"type":"string"}},{"name":"status","in":"query","required":false,"schema":{"type":"string"}},{"name":"pen","in":"query","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"object"}}}}}},"put":{"tags":["student-profile-controller"],"operationId":"updateStudentProfile","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StudentProfile"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfile"}}}}}},"post":{"tags":["student-profile-controller"],"operationId":"createStudentProfile","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StudentProfileCreate"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfile"}}}},"201":{"description":"CREATED","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfile"}}}}}}},"/api/v1/student-profile/{studentProfileRequestId}/documents/{documentID}":{"get":{"tags":["student-profile-document-controller"],"operationId":"readDocument","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string"}},{"name":"documentID","in":"path","required":true,"schema":{"type":"string"}},{"name":"includeDocData","in":"query","required":false,"schema":{"type":"string","default":"Y"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocument"}}}},"404":{"description":"NOT FOUND","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocument"}}}}}},"put":{"tags":["student-profile-document-controller"],"operationId":"updateDocument","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string","format":"uuid"}},{"name":"documentID","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StudentProfileDocument"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocMetadata"}}}}}},"delete":{"tags":["student-profile-document-controller"],"operationId":"deleteDocument","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string"}},{"name":"documentID","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocMetadata"}}}}}}},"/api/v1/student-profile/student-profile-macro/{macroId}":{"get":{"tags":["student-profile-macro-controller"],"operationId":"findPenReqMacroById","parameters":[{"name":"macroId","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileMacro"}}}},"404":{"description":"NOT FOUND","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileMacro"}}}}}},"put":{"tags":["student-profile-macro-controller"],"operationId":"updatePenReqMacro","parameters":[{"name":"macroId","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StudentProfileMacro"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileMacro"}}}},"404":{"description":"NOT FOUND","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileMacro"}}}}}}},"/api/v1/student-profile/{studentProfileRequestId}/documents":{"get":{"tags":["student-profile-document-controller"],"operationId":"readAllDocumentMetadata","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"object"}}}}}},"post":{"tags":["student-profile-document-controller"],"operationId":"createDocument","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StudentProfileDocument"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocMetadata"}}}},"201":{"description":"CREATED","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocMetadata"}}}}}}},"/api/v1/student-profile/{studentProfileRequestId}/comments":{"get":{"tags":["student-profile-comment-controller"],"operationId":"retrieveComments","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/StudentProfileComments"}}}}},"404":{"description":"NOT FOUND","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/StudentProfileComments"}}}}}}},"post":{"tags":["student-profile-comment-controller"],"operationId":"save","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StudentProfileComments"}}},"required":true},"responses":{"201":{"description":"CREATED","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileComments"}}}},"400":{"description":"BAD REQUEST","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileComments"}}}}}}},"/api/v1/student-profile/student-profile-macro":{"get":{"tags":["student-profile-macro-controller"],"operationId":"findPenReqMacros","parameters":[{"name":"macroTypeCode","in":"query","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/StudentProfileMacro"}}}}}}},"post":{"tags":["student-profile-macro-controller"],"operationId":"createPenReqMacro","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StudentProfileMacro"}}},"required":true},"responses":{"201":{"description":"CREATED","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileMacro"}}}}}}},"/api/v1/student-profile/documents":{"get":{"tags":["student-profile-document-controller"],"operationId":"readAllDocumentsMetadata","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/StudentProfileDocumentMetadata"}}}}}}},"post":{"tags":["student-profile-document-controller"],"operationId":"createDocument_1","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StudentProfileDocument"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocMetadata"}}}},"201":{"description":"CREATED","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocMetadata"}}}}}}},"/api/v1/student-profile/{studentProfileRequestId}":{"get":{"tags":["student-profile-controller"],"operationId":"retrieveStudentProfile","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfile"}}}},"404":{"description":"NOT FOUND","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfile"}}}}}},"delete":{"tags":["student-profile-controller"],"operationId":"deleteById","parameters":[{"name":"studentProfileRequestId","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"404":{"description":"NOT FOUND."},"204":{"description":"NO CONTENT"},"500":{"description":"INTERNAL SERVER ERROR."}}}},"/api/v1/student-profile/statuses":{"get":{"tags":["student-profile-controller"],"operationId":"getStudentProfileStatusCodes","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/StudentProfileStatusCode"}}}}}}}},"/api/v1/student-profile/stats":{"get":{"tags":["student-profile-controller"],"operationId":"getStats","parameters":[{"name":"statsType","in":"query","required":true,"schema":{"type":"string","enum":["COMPLETIONS_LAST_13_MONTH","ALL_STATUSES_LAST_12_MONTH","ALL_STATUSES_LAST_6_MONTH","ALL_STATUSES_LAST_1_MONTH","ALL_STATUSES_LAST_1_WEEK","COMPLETIONS_LAST_WEEK","AVERAGE_COMPLETION_TIME","PERCENT_UMP_COMPLETION_TO_LAST_MONTH","PERCENT_UMP_REJECTED_TO_LAST_MONTH","PERCENT_UMP_COMPLETED_WITH_DOCUMENTS_TO_LAST_MONTH","PERCENT_UMP_ABANDONED_TO_LAST_MONTH"]}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileStats"}}}},"500":{"description":"INTERNAL SERVER ERROR.","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileStats"}}}}}}},"/api/v1/student-profile/paginated":{"get":{"tags":["student-profile-controller"],"operationId":"findAll","parameters":[{"name":"pageNumber","in":"query","required":false,"schema":{"type":"integer","format":"int32","default":0}},{"name":"pageSize","in":"query","required":false,"schema":{"type":"integer","format":"int32","default":10}},{"name":"sort","in":"query","required":false,"schema":{"type":"string","default":""}},{"name":"searchCriteriaList","in":"query","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/PageStudentProfile"}}}},"500":{"description":"INTERNAL SERVER ERROR.","content":{"*/*":{"schema":{"$ref":"#/components/schemas/PageStudentProfile"}}}}}}},"/api/v1/student-profile/gender-codes":{"get":{"tags":["student-profile-controller"],"operationId":"getGenderCodes","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GenderCode"}}}}}}}},"/api/v1/student-profile/file-requirements":{"get":{"tags":["student-profile-document-controller"],"operationId":"getDocumentRequirements","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocRequirement"}}}}}}},"/api/v1/student-profile/documents/{documentID}":{"get":{"tags":["student-profile-document-controller"],"operationId":"readDocument_1","parameters":[{"name":"documentID","in":"path","required":true,"schema":{"type":"string"}},{"name":"includeDocData","in":"query","required":false,"schema":{"type":"string","default":"Y"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocument"}}}},"404":{"description":"NOT FOUND","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocument"}}}}}},"delete":{"tags":["student-profile-document-controller"],"operationId":"deleteDocument_1","parameters":[{"name":"documentID","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StudentProfileDocMetadata"}}}}}}},"/api/v1/student-profile/document-types":{"get":{"tags":["student-profile-document-controller"],"operationId":"getDocumentTypeCodes","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/StudentProfileDocTypeCode"}}}}}}}}},"components":{"schemas":{"StudentProfile":{"required":["digitalID","dob","email","emailVerified","legalLastName","recordedDob","recordedLegalLastName","recordedPen"],"type":"object","properties":{"createUser":{"maxLength":32,"minLength":0,"type":"string"},"updateUser":{"maxLength":32,"minLength":0,"type":"string"},"createDate":{"type":"string"},"updateDate":{"type":"string"},"studentRequestID":{"type":"string"},"digitalID":{"type":"string"},"studentRequestStatusCode":{"maxLength":10,"minLength":0,"type":"string"},"legalFirstName":{"maxLength":40,"minLength":0,"type":"string"},"legalMiddleNames":{"maxLength":255,"minLength":0,"type":"string"},"legalLastName":{"maxLength":40,"minLength":0,"type":"string"},"dob":{"type":"string"},"genderCode":{"maxLength":1,"minLength":0,"type":"string"},"email":{"maxLength":255,"minLength":0,"type":"string"},"recordedPen":{"type":"string"},"recordedLegalFirstName":{"maxLength":40,"minLength":0,"type":"string"},"recordedLegalMiddleNames":{"maxLength":255,"minLength":0,"type":"string"},"recordedLegalLastName":{"maxLength":40,"minLength":0,"type":"string"},"recordedDob":{"type":"string"},"recordedGenderCode":{"maxLength":1,"minLength":0,"type":"string"},"recordedEmail":{"maxLength":255,"minLength":0,"type":"string"},"reviewer":{"maxLength":255,"minLength":0,"type":"string"},"failureReason":{"type":"string"},"initialSubmitDate":{"type":"string"},"statusUpdateDate":{"type":"string"},"emailVerified":{"maxLength":1,"minLength":0,"pattern":"[YN]","type":"string"},"completeComment":{"type":"string"}}},"StudentProfileDocument":{"required":["documentTypeCode","fileExtension","fileName","fileSize"],"type":"object","properties":{"createUser":{"maxLength":32,"minLength":0,"type":"string"},"updateUser":{"maxLength":32,"minLength":0,"type":"string"},"createDate":{"type":"string"},"updateDate":{"type":"string"},"documentID":{"type":"string"},"documentTypeCode":{"maxLength":10,"minLength":0,"type":"string"},"fileName":{"maxLength":255,"minLength":0,"type":"string"},"fileExtension":{"maxLength":255,"minLength":0,"type":"string"},"fileSize":{"type":"integer","format":"int32"},"documentData":{"type":"string"}}},"StudentProfileDocMetadata":{"required":["documentTypeCode","fileExtension","fileName","fileSize"],"type":"object","properties":{"documentID":{"type":"string"},"documentTypeCode":{"type":"string"},"fileName":{"type":"string"},"fileExtension":{"type":"string"},"fileSize":{"type":"integer","format":"int32"},"createDate":{"type":"string"}}},"StudentProfileMacro":{"required":["macroCode","macroText","macroTypeCode"],"type":"object","properties":{"createUser":{"maxLength":32,"minLength":0,"type":"string"},"updateUser":{"maxLength":32,"minLength":0,"type":"string"},"createDate":{"type":"string"},"updateDate":{"type":"string"},"macroId":{"type":"string"},"macroCode":{"maxLength":10,"minLength":0,"type":"string"},"macroTypeCode":{"maxLength":10,"minLength":0,"type":"string"},"macroText":{"maxLength":4000,"minLength":0,"type":"string"}}},"StudentProfileCreate":{"required":["digitalID","dob","email","emailVerified","legalLastName","recordedDob","recordedLegalLastName","recordedPen"],"type":"object","properties":{"createUser":{"maxLength":32,"minLength":0,"type":"string"},"updateUser":{"maxLength":32,"minLength":0,"type":"string"},"createDate":{"type":"string"},"updateDate":{"type":"string"},"studentRequestID":{"type":"string"},"digitalID":{"type":"string"},"studentRequestStatusCode":{"maxLength":10,"minLength":0,"type":"string"},"legalFirstName":{"maxLength":40,"minLength":0,"type":"string"},"legalMiddleNames":{"maxLength":255,"minLength":0,"type":"string"},"legalLastName":{"maxLength":40,"minLength":0,"type":"string"},"dob":{"type":"string"},"genderCode":{"maxLength":1,"minLength":0,"type":"string"},"email":{"maxLength":255,"minLength":0,"type":"string"},"recordedPen":{"type":"string"},"recordedLegalFirstName":{"maxLength":40,"minLength":0,"type":"string"},"recordedLegalMiddleNames":{"maxLength":255,"minLength":0,"type":"string"},"recordedLegalLastName":{"maxLength":40,"minLength":0,"type":"string"},"recordedDob":{"type":"string"},"recordedGenderCode":{"maxLength":1,"minLength":0,"type":"string"},"recordedEmail":{"maxLength":255,"minLength":0,"type":"string"},"reviewer":{"maxLength":255,"minLength":0,"type":"string"},"failureReason":{"type":"string"},"initialSubmitDate":{"type":"string"},"statusUpdateDate":{"type":"string"},"emailVerified":{"maxLength":1,"minLength":0,"pattern":"[YN]","type":"string"},"completeComment":{"type":"string"},"documentIDs":{"type":"array","items":{"type":"string"}}}},"StudentProfileComments":{"required":["commentContent"],"type":"object","properties":{"createUser":{"maxLength":32,"minLength":0,"type":"string"},"updateUser":{"maxLength":32,"minLength":0,"type":"string"},"createDate":{"type":"string"},"updateDate":{"type":"string"},"studentProfileCommentID":{"type":"string"},"studentRequestID":{"type":"string"},"staffMemberIDIRGUID":{"maxLength":50,"minLength":0,"type":"string"},"staffMemberName":{"maxLength":255,"minLength":0,"type":"string"},"commentContent":{"type":"string"},"commentTimestamp":{"type":"string"}}},"StudentProfileStatusCode":{"required":["description","displayOrder","effectiveDate","expiryDate","label"],"type":"object","properties":{"studentRequestStatusCode":{"type":"string"},"label":{"type":"string"},"description":{"type":"string"},"displayOrder":{"type":"integer","format":"int32"},"effectiveDate":{"type":"string"},"expiryDate":{"type":"string"}}},"StudentProfileStats":{"type":"object","properties":{"completionsInLastMonths":{"type":"object","additionalProperties":{"type":"integer","format":"int64"}},"completionsInLastWeek":{"type":"object","additionalProperties":{"type":"integer","format":"int64"}},"allStatsLastTwelveMonth":{"type":"object","additionalProperties":{"type":"integer","format":"int64"}},"allStatsLastSixMonth":{"type":"object","additionalProperties":{"type":"integer","format":"int64"}},"allStatsLastOneMonth":{"type":"object","additionalProperties":{"type":"integer","format":"int64"}},"allStatsLastOneWeek":{"type":"object","additionalProperties":{"type":"integer","format":"int64"}},"averageTimeToCompleteRequest":{"type":"number","format":"double"},"percentCompletedUmpToLastMonth":{"type":"number","format":"double"},"percentRejectedUmpToLastMonth":{"type":"number","format":"double"},"percentAbandonedUmpToLastMonth":{"type":"number","format":"double"},"percentUmpCompletedWithDocumentsToLastMonth":{"type":"number","format":"double"},"umpCompletedInCurrentMonth":{"type":"integer","format":"int64"},"umpAbandonedInCurrentMonth":{"type":"integer","format":"int64"},"umpRejectedInCurrentMonth":{"type":"integer","format":"int64"},"umpCompletedWithDocsInCurrentMonth":{"type":"integer","format":"int64"}}},"PageStudentProfile":{"type":"object","properties":{"totalPages":{"type":"integer","format":"int32"},"totalElements":{"type":"integer","format":"int64"},"size":{"type":"integer","format":"int32"},"content":{"type":"array","items":{"$ref":"#/components/schemas/StudentProfile"}},"number":{"type":"integer","format":"int32"},"sort":{"$ref":"#/components/schemas/SortObject"},"numberOfElements":{"type":"integer","format":"int32"},"pageable":{"$ref":"#/components/schemas/PageableObject"},"first":{"type":"boolean"},"last":{"type":"boolean"},"empty":{"type":"boolean"}}},"PageableObject":{"type":"object","properties":{"offset":{"type":"integer","format":"int64"},"sort":{"$ref":"#/components/schemas/SortObject"},"pageNumber":{"type":"integer","format":"int32"},"pageSize":{"type":"integer","format":"int32"},"paged":{"type":"boolean"},"unpaged":{"type":"boolean"}}},"SortObject":{"type":"object","properties":{"empty":{"type":"boolean"},"sorted":{"type":"boolean"},"unsorted":{"type":"boolean"}}},"GenderCode":{"type":"object","properties":{"genderCode":{"type":"string"},"label":{"type":"string"},"description":{"type":"string"},"displayOrder":{"type":"integer","format":"int32"},"effectiveDate":{"type":"string"},"expiryDate":{"type":"string"}}},"StudentProfileDocRequirement":{"type":"object","properties":{"maxSize":{"type":"integer","format":"int32"},"extensions":{"type":"array","items":{"type":"string"}}}},"StudentProfileDocumentMetadata":{"type":"object","properties":{"studentRequestID":{"type":"string"},"digitalID":{"type":"string"},"documentID":{"type":"string"},"documentTypeCode":{"type":"string"},"fileName":{"type":"string"},"fileExtension":{"type":"string"},"fileSize":{"type":"integer","format":"int32"},"createDate":{"type":"string"}}},"StudentProfileDocTypeCode":{"type":"object","properties":{"documentTypeCode":{"type":"string"},"label":{"type":"string"},"description":{"type":"string"},"displayOrder":{"type":"integer","format":"int32"},"effectiveDate":{"type":"string"},"expiryDate":{"type":"string"}}}}}}